<?php
/*
  Plugin Name: Wordpress Editor Lock
  Plugin URI:  http://wordpress.org/extend/plugins/wordpress-editor-lock/
  Description: Editor Lock is a plugin which allows WordPress administrator, selectively restrict other administrator users from accessing the WordPress theme and plugin editors.
  Author: WisdmLabs, Thane, India
  Author URI:http://wisdmlabs.com
  License: GPLv2 or later
  Version: 1.2
  Network: true
 */
/**
 * The plugin methods will not be changed until a new release of wordpress.
 * @api
 * @author WisdmLabs, Thane, India
 * @copyright 2012-2013 WisdmLabs
 * @license GPL
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 */
$str = substr(WP_PLUGIN_DIR, 0, $length = -19);

require_once($str . '/wp-includes/pluggable.php');

function selfURL()
{
    $s = empty($_SERVER["HTTPS"]) ? '' : ($_SERVER["HTTPS"] == "on") ? "s" : "";
    $protocol = strleft(strtolower($_SERVER["SERVER_PROTOCOL"]), "/") . $s;
    $port = ($_SERVER["SERVER_PORT"] == "80") ? "" : (":" . $_SERVER["SERVER_PORT"]);
    return $protocol . "://" . $_SERVER['SERVER_NAME'] . $port . $_SERVER['REQUEST_URI'];
}

function strleft($s1, $s2)
{
    return substr($s1, 0, strpos($s1, $s2));
}

/**
 * @global $elbw_itr
 * @global $elbw_current_user
 */
// include bloginfo( 'wpurl' ). '/wp-includes/capabilities.php';
//require_once(bloginfo( 'wpurl' )'/wp-includes/pluggable.php');
global $elbw_itr;
//global $elbw_current_user;
//echo get_option('elbw_locked_users');

/**
 * Function to add a new option name, 'elbw_locked_users' to the options database table.  
 * @return string Assigns a blank string to variable 'elbw_locked_users' 
 */
add_option('elbw_locked_users');
add_option('elbw_maintain_logs');
//echo date('l jS \of F Y h:i:s A') . '  UTC' . '</br>';
//delete_option( 'elbw_locked_users');
//delete_option( 'elbw_maintain_logs' );
// Code to remove the names from the Block List starts here -->

$elbw_message = '';
$matched = array();
foreach ($_POST as $key => $value)
{
    $elbw_message .= $key . ' ' . $value . '    ';
}
$elbw_demo_array = explode(',', get_option('elbw_locked_users'));

foreach ($elbw_demo_array as $elbw_paramName)
{
    if (( $elbw_paramName != null ) && ( $elbw_paramName != '' ) && ( $elbw_paramName != ' ' ) && ( $elbw_paramName != ' ' ))
    {
	$elbw_assignit = str_replace(' ', '', $elbw_paramName) . '_x';
	$elbw_pos = strpos($elbw_message, $elbw_assignit);

	if ($elbw_pos !== FALSE)
	{
	    $elbw_message = '';
	    $elbw_replace_string = get_option('elbw_locked_users');
	    $elbw_temp_string = ',' . $elbw_paramName;
	    $elbw_cutomized = str_replace($elbw_temp_string, '', $elbw_replace_string);
	    delete_option('elbw_locked_users');
	    add_option('elbw_locked_users', $elbw_cutomized);
	    preg_match('/[0-9]*[^\(\x20\)]/', $elbw_paramName, $matched);
	    $str1 = 'User ' . '<strong>' . get_user_meta($matched[0], 'nickname', true) . '</strong>';
	    $str2 = ' was <strong> removed </strong> from blocklist by ';
	    $str3 = '<strong>' . get_user_meta(get_current_user_id(), 'nickname', true) . '</strong>';
	    update_option('elbw_maintain_logs', date('l jS \of F Y h:i:s A') . '  UTC  ---' . ' <strong>   Info : </strong> ' . $str1 . $str2 . $str3 . ',' . get_option('elbw_maintain_logs'));
	    //echo get_option( 'elbw_maintain_logs' );
	}
	$elbw_assignit = '';
    }
}
//Code to remove the names from the Block List ends here -->

/**
 * This function adds a user in the block list    
 * @param string $_POST['elbw_submit']  It is a value obtained from the form
 * @return string Adds a username into the database option 'elbw_locked_users'
 */
if ($_POST['elbw_delete_logs'])
{
    delete_option('elbw_maintain_logs');
    add_option('elbw_maintain_logs');
}



if ($_POST['elbw_submit'])
{
    $elbw_itr = $_POST['elbw_getadmins'];
    if ($elbw_itr != 1)
    {
	$elbw_user_info = $elbw_user_info . '(' . $elbw_itr . ')';

	if (strpos(get_option('elbw_locked_users'), $elbw_user_info) === FALSE)
	{
	    update_option('elbw_locked_users', get_option('elbw_locked_users') . ',' . $elbw_user_info);
	    $str1 = 'User ' . '<strong>' . get_user_meta($elbw_itr, 'nickname', true) . '</strong>';
	    $str2 = ' was <strong> added </strong> to blocklist by ';
	    $str3 = '<strong>' . get_user_meta(get_current_user_id(), 'nickname', true) . '</strong>';
	    update_option('elbw_maintain_logs', date('l jS \of F Y h:i:s A') . '  UTC  ---' . ' <strong>   Info : </strong> ' . $str1 . $str2 . $str3 . ',' . get_option('elbw_maintain_logs'));
	    //echo get_option( 'elbw_maintain_logs' );
	}
    }
}

/**
 * These hooks defines that while deactivating or uninstalling the plugin, database option 'elbw_locked_users' should be deleted.
 */
register_uninstall_hook(__FILE__, 'elbw_deactivate');

/* function get_info_of_user()
  {
  $elbw_current_user = wp_get_current_user();
  return $elbw_current_user->ID;

  } */

/**
 * Hook for Hiding Plugin Editor and Theme Editor 
 */
add_action('admin_menu', 'elbw_my_remove_menu_elements', 102);
add_action('admin_init', 'elbw_my_remove_menu_elements', 102);
add_action('delete_user', 'elbw_cannot_delete');

/**
 * This Function Creates a Setting Menu
 */
add_action('admin_menu', 'elbw_baw_create_menu');

/**
 * Function to be called while deactivating or uninstalling the plugin. It would Delete the 'elbw_locked_users' option from the database.
 */
function elbw_deactivate()
{
    delete_option('elbw_locked_users');
    delete_option('elbw_maintain_logs');
}

// Function to Remove Editing Access from the selected Administrators STARTS here -->
function elbw_my_remove_menu_elements()
{
    $elbw_current_user = wp_get_current_user();
    $elbw_temp = '(' . $elbw_current_user->ID . ')';
    if (strpos(get_option('elbw_locked_users'), $elbw_temp) !== FALSE)
    {
	remove_submenu_page('plugins.php', 'plugin-editor.php');
	remove_submenu_page('themes.php', 'theme-editor.php');
	//add_action( 'edit_user_profile', 'elbw_cannot_delete' );
	$elbw_pages = array('theme-editor.php', 'plugin-editor.php');
	foreach ($elbw_pages as $elbw_page)
	{
	    if (strpos($_SERVER['PHP_SELF'], $elbw_page))
	    {
		$str1 = 'User ' . '<strong>' . get_user_meta(get_current_user_id(), 'nickname', true) . '</strong>';
		$str2 = ' tried to access the following forbidden page :  <a href="' . selfURL() . '"> <strong>' . selfURL() . '</strong> </a>';
		update_option('elbw_maintain_logs', date('l jS \of F Y h:i:s A') . '  UTC  ---' . ' <strong>   Alert : </strong> ' . $str1 . $str2 . ',' . get_option('elbw_maintain_logs'));
		wp_die(__('Page disabled by the administrator. </br> </br> This activity has been logged!'));
	    }
	}
	add_action('delete_user', 'elbw_cannot_delete');
	add_filter('plugin_action_links', 'elbw_disable_plugin_deactivation', 10, 4);
    }
}

// Function to Remove Editing Access from the selected Administrators ENDS here -->

/**
 * This function prevents the user in the blocklist from deleting any other user
 * @return string Die Message
 */
function elbw_cannot_delete()
{
    $check_if_admin = '&user=1&';
    $check_if_admin = strpos(selfURL(), $check_if_admin);
    if ($check_if_admin !== FALSE)
    {
	$str1 = 'User ' . '<strong>' . get_user_meta(get_current_user_id(), 'nickname', true) . '</strong>';
	$str2 = ' tried to delete the Main Administrator :  <strong>' . get_user_meta(1, 'nickname', true) . '</strong>';
	update_option('elbw_maintain_logs', date('l jS \of F Y h:i:s A') . '  UTC  ---' . ' <strong>   Alert : </strong> ' . $str1 . $str2 . ',' . get_option('elbw_maintain_logs'));
	wp_die(__('Sorry! You are not allowed to delete <strong> ' . get_user_meta(1, 'nickname', true) . ' </strong> </br>' . 'This activity has been logged!'));
    }
}

/**
 * This function disables 'Deactivate' Link for the blocked users 
 */
function elbw_disable_plugin_deactivation($actions, $plugin_file)
{

    // Remove deactivate link for  plugin
    if (array_key_exists('deactivate', $actions) && in_array($plugin_file, array('editor-lock-by-wisdmlabs/editor-lock.php')))
	unset($actions['deactivate']);
    return $actions;
}

/**
 * Function to create a settings page for the users who are not blocked
 */
function elbw_baw_create_menu()
{
    $elbw_current_user = wp_get_current_user();
    $elbw_temp = '(' . $elbw_current_user->ID . ')';

    $elbw_temp = strpos(get_option('elbw_locked_users'), $elbw_temp);


    if ($elbw_temp === FALSE)
    {
	$myicon = plugins_url() . "/editor-lock-by-wisdmlabs/images/icon.png";
	//create new top-level menu
	add_menu_page('Editor Lock Settings', 'Editor Lock', 'administrator', __FILE__, 'elbw_baw_settings_page', $myicon);

	//call register settings function
	add_action('admin_menu', 'elbw_register_mysettings');
    }
}

/**
 * This function register the settings
 */
function elbw_register_mysettings()
{
    register_setting('elbw_baw-settings-group', 'elbw_locked_users');
}

//Editor Lock Settings Page STARTS Here -->

function elbw_baw_settings_page()
{
    global $wpdb;
    $elbw_array_of_admins = array();
    global $elbw_fetch_database;
    $elbw_fetch_database = $wpdb->get_var('SELECT * FROM `wp_usermeta` ORDER BY `user_id` DESC', 1);
    while ($elbw_fetch_database >= 2)
    {
	$elbw_search_admins = get_user_meta($elbw_fetch_database, 'wp_user_level', true);
	if ($elbw_search_admins == 10)
	{
	    $elbw_array_of_admins[] = $elbw_fetch_database;
	}
	$elbw_fetch_database = $elbw_fetch_database - 1;
    }
    ?> 
    <style type="text/css">

        #alertlink a:link {color:#696969;}    /* unvisited link */
        #alertlink a:visited {color:#696969;} /* visited link */
        #alertlink a:hover {color:#FF3300;}   /* mouse over link */
        #alertlink a:active {color:#90EE90;}  /* selected link */

    </style>

    <div style='float: left;margin-top: 1%; font-size:15px; font-weight:bold;'>
        <h2>WordPress Editor Lock by  </h2>
    </div>
    <div class='wrap' style="margin-bottom: 5%;">
        <div style='float:left'>
    	<img src='<?php bloginfo('wpurl'); ?>/wp-content/plugins/editor-lock-by-wisdmlabs/images/WisdmLabs-Logo.jpg'  style="margin-top: 4%;"/>
        </div> 
        </br>
        <div style='float:right'> 
    	<form action='https://www.paypal.com/cgi-bin/webscr' method='post'>
    	    <input type='hidden' name='cmd' value='_donations'>
    	    <input type='hidden' name='business' value='info@wisdmlabs.com'>
    	    <input type='hidden' name='lc' value='IN'>
    	    <input type='hidden' name='item_name' value='WisdmLabs'>
    	    <input type='hidden' name='no_note' value=''>
    	    <input type='hidden' name='currency_code' value='USD'>
    	    <input type='hidden' name='bn' value='PP-DonationsBF:btn_donate_SM.gif:NonHostedGuest'>
    	    <input type='image' src='https://www.paypalobjects.com/en_GB/i/btn/btn_donate_SM.gif' border='0' name='submit' alt='PayPal — The safer, easier way to pay online.'>
    	    <img alt='' border='0' src='https://www.paypalobjects.com/en_US/i/scr/pixel.gif' width='1' height='1' />
    	</form>
        </div>
        <div style='margin-top: 1%; font-size:15px; font-weight:bold;'>
    	<h3 style="width: 15%;"> Plugin Settings </h3>
        </div>	
        </br>
        <form method='post' action="<?php echo $_SERVER['$PHP_SELF']; ?>">
    	<div>
    	    <div style="float:left">
    		<strong scope='row'>Select the Administrator user to be blocked from accessing the editors : </strong>
    	    </div>
    	     <!-- <div><input type='text' name='new_option_name' value='' /> </div> -->
    	    <div style="float: left; width: 20%; margin-left: 1%; margin-top: -1%;"> 
    		<select name='elbw_getadmins'>
			<?php
			//Displaying All Administrators in the Drop-Down List
			foreach ($elbw_array_of_admins as $elbw_get_user_name)
			{
			    if ($elbw_get_user_name != get_current_user_id())
			    {
				?>
	    		    <option value='<?php echo $elbw_get_user_name; ?>'>
				    <?php echo get_user_meta($elbw_get_user_name, 'nickname', true); ?>
	    		    </option> 
			    <?php }
			}
			?>
    		</select> 
    		<span class='submit'> <input class='submit' onclick="return confirm('Are you sure you want to block this user from accessing Plugin-Editor and Theme-Editor?');" type='submit' name='elbw_submit' value= 'Submit' /> </span>
    	    </div>
    	    </br>
    	    <div style="margin-top: 2px; margin-bottom: 13px; padding-top: 4%;  text-align: left; clear:both;">
    		<b>List of blocked users : </b>
    	    </div>
    	    <div id="hee" style="width:25% ; height:150px ; overflow : auto"> <?php
		    /**
		     * Displaying the list of Blocked Users
		     */
		    $matched = array();
		    $elbw_temp_array = explode(',', get_option('elbw_locked_users', ''));
		    //print_r($elbw_temp_array);
		    foreach ($elbw_temp_array as $elbw_paramName)
		    {
			if (!empty($elbw_paramName))
			{
			    preg_match('/[0-9]*[^\(\x20\)]/', $elbw_paramName, $matched);
			    ?>
	    		<div style="height:30px">
	    		    <div id="blockedlist" style="width:110px ; float:left;"> <?php echo get_user_meta($matched[0], 'nickname', true); ?> </div>


	    		    <div style="float:right; margin:-1.5% ;">  
	    			<input type='image' onclick="return confirm('Are you sure you want to allow this user to access Plugin-Editor and Theme-Editor?');" name='<?php echo str_replace(' ', '', $elbw_paramName); ?>' src='<?php bloginfo('wpurl'); ?>/wp-content/plugins/editor-lock-by-wisdmlabs/images/cross.gif'/> 
	    		    </div> 
	    		</div>
			<?php }
		    }
		    ?>


    	    </div>

    	</div>
        </form>
        </br> </br>
        <div style="margin-top:5%;" >
    	<b>Recent Activities : </b>
	    <?php
	    $elbw_temp_array = explode(',', get_option('elbw_maintain_logs'));
	    $elbw_temp_array = array_slice($elbw_temp_array, 0, 20);
	    foreach ($elbw_temp_array as $elbw_paramName)
	    {
		  if (strpos($elbw_paramName, 'Alert :') !== FALSE)
		  {
		    ?> <div id="alertlink" style="background-color:#FFFFCC ; color : #FF3300; padding:5px"> <?php echo $elbw_paramName; ?> </div> <?php
		  }
		  else
		  {
		    ?> <div style="background-color:#FFFFCC ; padding:5px"> <?php echo $elbw_paramName; ?> </div> <?php
		  }
	    } ?> 
        </div>
	 <?php if (get_current_user_id() == 1)
	 { ?>
	    <div style="margin-top:2%; margin-bottom: 3%;">
	       <form method="post">
		  <span>
		     <input  class="button-primary" onclick="return confirm('Are you sure that you want to delete logs ?');" type='submit' name='elbw_delete_logs' value= 'Clear Logs' />
		  </span>
	       </form>
	    </div> <?php
	 } ?>
    </div>
    <?php }////Editor Lock Settings Page ENDS Here --> ?>